% fipmca
% TNS anne 2003
% Variables alatoires 1
% Programme: ala1_5.m

clear all
Nunif=12 ; % Nbre de v.a. uniformes [0 1] dans  a aditionner

% Paramtres pour l'histogramme de la somme de v.a. uniformes
% -----------------------------------------------------------
N=100000 ;        % Nbre de realisations
Nclasse=50 ;     % On a Nclasse entre la plus petite et la plus grande realisation

% Tirages
% -------
X=sum(rand(Nunif,N)) ;

% Estimation de la densit de la somme de Nunif 
% v.a. de loi uniforme dans l'intervalle [0 1]
% ------------------------------------------------
[histo,x]=hist(X,Nclasse) ;
delta=x(2)-x(1) ;
densite_est=(1/N)*(1/delta)*histo ;
figure(1)
bar(x,densite_est,1) ;

% Densit exacte
% --------------
mu=Nunif*0.5; sigma2=Nunif*(1/12) ; % moyenne et variance de la gaussienne (th limite centrale)

xx=linspace(min(X),max(X),1000) ;
densite=(1/sqrt(2*pi*sigma2))*exp(-(0.5/sigma2)*(xx-mu).^2) ;

hold on
plot(xx,densite,'r') 
hold off
