% fichier tfd00122.m
%
% fipmca  15/10/2003
%
% TP TFD
%
% 1.2.2 rsolution en frquence

clear all
close all

N=32;L=4096;
n=0:N-1;

Fe=0.2;Te=1/Fe;

A0=1;fr0=0.250;
x0=A0*sin(2*pi*fr0*n*Te);
A1=A0;fr1=0.229;
x1=A1*sin(2*pi*fr1*n*Te);

x=x0+x1;

X0=abs(fft(x0,L));
X1=abs(fft(x1,L));
X=abs(fft(x,L));

freq_reduite=linspace(0,1-1/L,L);

figure(1)
stem(n,x)

figure(2)
plot(freq_reduite,X0,'c')
hold on
plot(freq_reduite,X1,'g')
grid,zoom

figure(3)
plot(freq_reduite,X)
grid,zoom
title('mise en vidence de la rsolution en frquence')

% Conclusion
% La rsolution en frquence dpend de la largeur du lobe principal du
% spectre de la fentre, LLP. Pour la fentre rectangulaire, cette largeur
% est gale  2*Fe/N. La rsolution en frquence est de l'ordre de LLP/2.
% Le seul moyen d'augmenter la rsolution en frquence est donc d'augmenter
% N, nombre d'chantillons du signal.