% fichier tfd00123.m
%
% fipmca  15/10/2003
%
% TP TFD
%
% 1.2.3 rsolution en amplitude

clear all
close all

N=32;L=4096;
n=0:N-1;

Fe=1;Te=1/Fe;

A0=1;fr0=0.250;
x0=A0*sin(2*pi*fr0*n*Te);
A1=A0/3;fr1=0.205;
x1=A1*sin(2*pi*fr1*n*Te);

x=x0+x1;

X0=abs(fft(x0,L));
X1=abs(fft(x1,L));
X=abs(fft(x,L));

freq_reduite=linspace(0,1-1/L,L);

figure(1)
stem(n,x)

figure(2)
plot(freq_reduite,X0,'c')
hold on
plot(freq_reduite,X1,'y')
grid,zoom

figure(3)
plot(freq_reduite,X)
grid,zoom
title('mise en vidence de la rsolution en amplitude')


AA0=1;fr0=0.250;
xx0=AA0*sin(2*pi*fr0*n*Te);
AA1=AA0/20;fr1=0.205;
xx1=AA1*sin(2*pi*fr1*n*Te);

xx=xx0+xx1;

XX0=abs(fft(xx0,L));
XX1=abs(fft(xx1,L));
XX=abs(fft(xx,L));

figure(4)
plot(freq_reduite,XX)
grid,zoom
title('mise en vidence de la rsolution en amplitude')

% Conclusion
% La rsolution en amplitude dpend de l'amplitude du lobe secondaire 
% relativement  celle du lobe principal du spectre de la fentre. 
% Ce rapport est souvent exprim en dB. Pour la fentre rectangulaire, 
% sa valeur est gale  -13.5 dB.
%
% Le seul moyen d'amliorer la rsolution en amplitude consiste  choisir
% une fentre qui prsente un rapport plus favorable (Hamming ~= -43 dB ...
% voir tableau cours filtrage).
%
% Cependant, pour N fix, la largeur du lobe principal augmente. 
% La rsolution en frquence s'en trouve dtriore.